#include <iostream>
#include <vector>
#include <stdlib.h>
#include <stdio.h>
#include "Engine.h"


Engine::Engine(){
	Board* brd = new Board();
	b = brd;
}

void Engine::startGame(){
	cout<<"WELCOME\n";
	
	cout<<"1. Play against AI?\n";
	cout<<"2. Play against a human?\n";
	cout<<"Enter choice: \n";

	int choice = -1;
	cin >> choice;
	cout << "OK" << endl;

	string move;

	bool gameOver = false; 
	vector<Board> record;
	b->snapshot(record, *b);

	while (gameOver != true)
	{
		gameOver = b->isGameOver();
		
		while(b->getTurn() == 'O' && !b->isValid())
		{
			b->displayBoard();
			cout<<"\nEnter command: ";
			cin>>move;
			cout << "\n";
			b->interpret(move, *b);
			if(b->isValid()) {
				b->changeTurns();
				b->setValidFalse();
			}
		}
		
		if(b->isValid()) cout << b->getTurn();
		
		while(b->getTurn() == 'X' )
		{
			easyAI();
		}
		
		gameOver = b->isGameOver();
		b->setValidFalse();
		
		b->snapshot(record, *b);
	}
}

void Engine::easyAI()
{
	vector<moves> listOfMoves = b->viewPossibleMoves();
	/*
	for(int x = 0; x < listOfMoves.size(); ++x) {
		cout << listOfMoves[x].row << " " << listOfMoves[x].column << " " << listOfMoves[x].moveType << "\n\n";
	}
	*/
	srand(time(NULL));
	int randomChoice = rand() % (listOfMoves.size()-1) - 0;
	
	int temp = randomChoice;
	cout << "easy AI  move: " << listOfMoves[randomChoice].row << listOfMoves[randomChoice].column << listOfMoves[randomChoice].moveType << "\n";
	b->move(listOfMoves[randomChoice]);
	b->changeTurns();
}

void Engine::AI(){
	cout << "----------------------BEGIN AI FUNCTION----------------------\n";
	vector<moves> listOfMoves = b->viewPossibleMoves();
	//Board* b = new Board(*b);
	
	//probably not needed, check later
	/*
	if (b->getTurn() != 'X'){
		cout << "a changing of turns is needed. \n";
		b->changeTurns();
	}
	*/
	//only doing 1 branch right now because testing
	/*for (int i = 0; i < listOfMoves.size(); ++i){
		minMax(b, listOfMoves[i]);
	}*/
	
	b->move(minMax(listOfMoves[0], 0));
	b->changeTurns();
	
	//verification of correct turn
	/*
	if (b->getTurn() != 'O'){
		cout << "ERROR in Engine::AI: b is on the wrong turn. \n";
	}
	*/
	b->displayBoard();
	cout << "----------------------END AI FUNCTION----------------------\n";
}

moves Engine::minMax(moves m, int c){
	//testing purposes only, c = finite depth
	/*
	if (c > 5){		
		return m;
	}
	
	if (b->isGameOver() == true){
		cout << "END OF PATH REACHED\n";
		return m;
	}

	else {
		if(b->isThisMovePossible(8 - m.row, b->charToIntColumn(m.column), m.moveType)){
			cout << "piece has been moved in minMax\n";
			b->move(m);
			b->changeTurns();
		}
		cout << "c: " << c << "\n\n";
		cout << "current turn: " << b->getTurn() << "\n";
		vector<moves> listOfMoves = b->viewPossibleMoves();
		
		for (int i = 0; i < listOfMoves.size(); ++i){
			//return minMax(b, listOfMoves[i]);
		}
		
		b->displayBoard();
		//limited recursion
		return minMax(b, listOfMoves[0], ++c);
		
		//testing
		return m;
	}*/
}